#include <perms.h>
// option...
int _imp_mainep(int _imp_argc, char **_imp_argv) {
  _imp_enter();
  const _imp_string NULL = _imp_str_literal("");
  const _imp_string TEN = _imp_str_literal("1234567890");
  const _imp_string ALPHABET = _imp_str_literal("ABCDEFGHIJKLMNOPQRSTUVWXYZ");
  const _imp_string TRIPLE1 = _imp_str_literal("ABC");
  const _imp_string TRIPLE2 = _imp_str_literal("DEF");
  const _imp_string TRIPLE3 = _imp_str_literal("GHI");
  _imp_string ALPHA;
  _imp_string BETA;
  _imp_string GAMMA;
  _imp_string DELTA;
  static int FAILURES = 0;
  auto void PASS(void) {
    _imp_enter();
    PRINTSTRING(_imp_str_literal("Pass: "));
    _imp_leave();
  }
  auto void FAIL(void) {
    _imp_enter();
    PRINTSTRING(_imp_str_literal("FAIL: "));
    FAILURES = FAILURES + 1;
    _imp_leave();
  }
  OPENOUTPUT(2, _imp_str_literal("Journal"));
  SELECTOUTPUT(2);
  NEWLINES(2);
  PRINTSTRING(_imp_str_literal("%String Procedure Validation"));
  NEWLINE();
  PRINTSTRING(_imp_str_literal("----------------------------"));
  NEWLINES(2);
  PRINTSTRING(_imp_str_literal("Entities:"));
  NEWLINE();
  PRINTSTRING(_imp_str_literal("-------- "));
  NEWLINES(2);
  PRINTSTRING(_imp_str_literal("Constants:     Triple1 = \"ABC\""));
  NEWLINE();
  PRINTSTRING(_imp_str_literal("               Triple2 = \"DEF\""));
  NEWLINE();
  PRINTSTRING(_imp_str_literal("               Triple3 = \"GHI\""));
  NEWLINE();
  PRINTSTRING(_imp_str_literal("               Null    = \"\""));
  NEWLINE();
  PRINTSTRING(_imp_str_literal("               Ten     = \"1234567890\""));
  NEWLINE();
  PRINTSTRING(_imp_str_literal(
      "               Alphabet= \"ABCEEFGHIJKLMNOPQRSTUVWXYZ\""));
  NEWLINES(2);
  PRINTSTRING(_imp_str_literal("Variables:     Alpha   = %String(4)"));
  NEWLINE();
  PRINTSTRING(_imp_str_literal("               Beta    = %String(255)"));
  NEWLINE();
  PRINTSTRING(_imp_str_literal("               Gamma   = %String(255)"));
  NEWLINES(2);
  if (_imp_str_literal("ABC") == _imp_str_literal("ABC"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("\"ABC\" = \"ABC\""));
  NEWLINE();
  if (TRIPLE1 == _imp_str_literal("ABC"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Triple1 = \"ABC\""));
  NEWLINE();
  if (_imp_str_literal("ABC") == TRIPLE1)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("\"ABC\" = Triple1"));
  NEWLINE();
  if (TRIPLE1 == TRIPLE1)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Triple1 = Triple1"));
  NEWLINE();
  NEWLINES(3);
  PRINTSTRING(_imp_str_literal("Let:    Alpha = Beta = Triple1"));
  NEWLINE();
  PRINTSTRING(_imp_str_literal("---"));
  NEWLINES(2);
  ALPHA = TRIPLE1;
  BETA = TRIPLE1;
  if (ALPHA == TRIPLE1)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Alpha = Triple1"));
  NEWLINE();
  if (TRIPLE1 == ALPHA)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Triple1 = Alpha"));
  NEWLINE();
  if (ALPHA == BETA)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Alpha = Beta"));
  NEWLINE();
  if (ALPHA == ALPHA)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Alpha = Alpha"));
  NEWLINE();
  if (ALPHA == _imp_str_literal("ABC"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Alpha = \"ABC\""));
  NEWLINE();
  if (_imp_str_literal("ABC") == ALPHA)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("\"ABC\" = Alpha"));
  NEWLINES(2);
  if (_imp_str_literal("ABC") != _imp_str_literal("ABC"))
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("\"ABC\" # \"ABC\""));
  NEWLINE();
  if (TRIPLE1 != _imp_str_literal("ABC"))
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("Triple1 # \"ABC\""));
  NEWLINE();
  if (_imp_str_literal("ABC") != TRIPLE1)
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("\"ABC\" # Triple1"));
  NEWLINE();
  if (TRIPLE1 != TRIPLE1)
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("Triple1 # Triple1"));
  NEWLINE();
  if (ALPHA != TRIPLE1)
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("Alpha # Triple1"));
  NEWLINE();
  if (TRIPLE1 != ALPHA)
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("Triple1 # Alpha"));
  NEWLINE();
  if (ALPHA != BETA)
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("Alpha # Beta"));
  NEWLINE();
  if (ALPHA != ALPHA)
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("Alpha # Alpha"));
  NEWLINE();
  if (ALPHA != _imp_str_literal("ABC"))
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("Alpha # \"ABC\""));
  NEWLINE();
  if (_imp_str_literal("ABC") != ALPHA)
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("\"ABC\" # Alpha"));
  NEWLINES(2);
  ALPHA = TRIPLE1;
  if (_imp_str_literal("ABC") < _imp_str_literal("ABC"))
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("\"ABC\" < \"ABC\""));
  NEWLINE();
  if (_imp_str_literal("ABC") < ALPHA)
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("\"ABC\" < Alpha"));
  NEWLINE();
  if (ALPHA < _imp_str_literal("ABC"))
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("Alpha < \"ABC\""));
  NEWLINE();
  if (_imp_str_literal("ABC") < TRIPLE1)
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("\"ABC\" < Triple1"));
  NEWLINE();
  if (TRIPLE1 < _imp_str_literal("ABC"))
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("Triple1 < \"ABC\""));
  NEWLINE();
  if (ALPHA < TRIPLE1)
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("Alpha < Triple1"));
  NEWLINE();
  if (TRIPLE1 < ALPHA)
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("Triple1 < Alpha"));
  NEWLINE();
  if (TRIPLE1 < TRIPLE1)
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("Triple1 < Triple1"));
  NEWLINE();
  if (ALPHA < ALPHA)
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("Alpha < Alpha"));
  NEWLINES(2);
  ALPHA = TRIPLE1;
  if (_imp_str_literal("ABC") <= _imp_str_literal("ABC"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("\"ABC\" <= \"ABC\""));
  NEWLINE();
  if (_imp_str_literal("ABC") <= ALPHA)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("\"ABC\" <= Alpha"));
  NEWLINE();
  if (ALPHA <= _imp_str_literal("ABC"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Alpha <= \"ABC\""));
  NEWLINE();
  if (_imp_str_literal("ABC") <= TRIPLE1)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("\"ABC\" <= Triple1"));
  NEWLINE();
  if (TRIPLE1 <= _imp_str_literal("ABC"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Triple1 <= \"ABC\""));
  NEWLINE();
  if (ALPHA <= TRIPLE1)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Alpha <= Triple1"));
  NEWLINE();
  if (TRIPLE1 <= ALPHA)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Triple1 <= Alpha"));
  NEWLINE();
  if (TRIPLE1 <= TRIPLE1)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Triple1 <= Triple1"));
  NEWLINE();
  if (ALPHA <= ALPHA)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Alpha <= Alpha"));
  NEWLINE();
  ALPHA = TRIPLE1;
  if (_imp_str_literal("ABC") > _imp_str_literal("ABC"))
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("\"ABC\" > \"ABC\""));
  NEWLINE();
  if (_imp_str_literal("ABC") > ALPHA)
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("\"ABC\" > Alpha"));
  NEWLINE();
  if (ALPHA > _imp_str_literal("ABC"))
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("Alpha > \"ABC\""));
  NEWLINE();
  if (_imp_str_literal("ABC") > TRIPLE1)
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("\"ABC\" > Triple1"));
  NEWLINE();
  if (TRIPLE1 > _imp_str_literal("ABC"))
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("Triple1 > \"ABC\""));
  NEWLINE();
  if (ALPHA > TRIPLE1)
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("Alpha > Triple1"));
  NEWLINE();
  if (TRIPLE1 > ALPHA)
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("Triple1 > Alpha"));
  NEWLINE();
  if (TRIPLE1 > TRIPLE1)
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("Triple1 > Triple1"));
  NEWLINE();
  if (ALPHA > ALPHA)
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("Alpha > Alpha"));
  NEWLINE();
  ALPHA = TRIPLE1;
  if (_imp_str_literal("ABC") >= _imp_str_literal("ABC"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("\"ABC\" >= \"ABC\""));
  NEWLINE();
  if (_imp_str_literal("ABC") >= ALPHA)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("\"ABC\" >= Alpha"));
  NEWLINE();
  if (ALPHA >= _imp_str_literal("ABC"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Alpha >= \"ABC\""));
  NEWLINE();
  if (_imp_str_literal("ABC") >= TRIPLE1)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("\"ABC\" >= Triple1"));
  NEWLINE();
  if (TRIPLE1 >= _imp_str_literal("ABC"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Triple1 >= \"ABC\""));
  NEWLINE();
  if (ALPHA >= TRIPLE1)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Alpha >= Triple1"));
  NEWLINE();
  if (TRIPLE1 >= ALPHA)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Triple1 >= Alpha"));
  NEWLINE();
  if (TRIPLE1 >= TRIPLE1)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Triple1 >= Triple1"));
  NEWLINE();
  if (ALPHA >= ALPHA)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Alpha >= Alpha"));
  NEWLINES(4);
  if (_imp_str_literal("ABC") == _imp_str_literal("DEF"))
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("\"ABC\" = \"DEF\""));
  NEWLINE();
  if (TRIPLE1 == _imp_str_literal("DEF"))
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("Triple1 = \"DEF\""));
  NEWLINE();
  if (_imp_str_literal("DEF") == TRIPLE1)
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("\"DEF\" = Triple1"));
  NEWLINE();
  if (TRIPLE1 == TRIPLE2)
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("Triple1 = Triple2"));
  NEWLINES(2);
  PRINTSTRING(_imp_str_literal("Let:   Alpha = Triple1"));
  NEWLINE();
  PRINTSTRING(_imp_str_literal("---    Beta  = Triple2"));
  NEWLINES(2);
  ALPHA = TRIPLE1;
  BETA = TRIPLE2;
  if (ALPHA == TRIPLE2)
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("Alpha = Triple2"));
  NEWLINE();
  if (TRIPLE2 == ALPHA)
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("Triple2 = Alpha"));
  NEWLINE();
  if (ALPHA == BETA)
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("Alpha = Beta"));
  NEWLINE();
  if (ALPHA == _imp_str_literal("DEF"))
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("Alpha = \"DEF\""));
  NEWLINE();
  if (_imp_str_literal("DEF") == ALPHA)
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("\"DEF\" = Alpha"));
  NEWLINES(2);
  if (_imp_str_literal("ABC") != _imp_str_literal("DEF"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("\"ABC\" # \"DEF\""));
  NEWLINE();
  if (TRIPLE1 != _imp_str_literal("DEF"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Triple1 # \"DEF\""));
  NEWLINE();
  if (_imp_str_literal("DEF") != TRIPLE1)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("\"DEF\" # Triple1"));
  NEWLINE();
  if (TRIPLE1 != TRIPLE2)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Triple1 # Triple2"));
  NEWLINE();
  if (ALPHA != TRIPLE2)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Alpha # Triple2"));
  NEWLINE();
  if (TRIPLE2 != ALPHA)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Triple2 # Alpha"));
  NEWLINE();
  if (ALPHA != BETA)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Alpha # Beta"));
  NEWLINE();
  if (ALPHA != _imp_str_literal("DEF"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Alpha # \"DEF\""));
  NEWLINE();
  if (_imp_str_literal("DEF") != ALPHA)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("\"DEF\" # Alpha"));
  NEWLINES(2);
  if (_imp_str_literal("ABC") < _imp_str_literal("DEF"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("\"ABC\" < \"DEF\""));
  NEWLINE();
  if (_imp_str_literal("DEF") < ALPHA)
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("\"DEF\" < Alpha"));
  NEWLINE();
  if (ALPHA < _imp_str_literal("DEF"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Alpha < \"DEF\""));
  NEWLINE();
  if (_imp_str_literal("DEF") < TRIPLE1)
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("\"DEF\" < Triple1"));
  NEWLINE();
  if (TRIPLE1 < _imp_str_literal("DEF"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Triple1 < \"DEF\""));
  NEWLINE();
  if (ALPHA < TRIPLE2)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Alpha < Triple2"));
  NEWLINE();
  if (TRIPLE2 < ALPHA)
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("Triple2 < Alpha"));
  NEWLINE();
  if (TRIPLE1 < TRIPLE2)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Triple1 < Triple2"));
  NEWLINES(2);
  if (_imp_str_literal("ABC") <= _imp_str_literal("DEF"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("\"ABC\" <= \"DEF\""));
  NEWLINE();
  if (_imp_str_literal("DEF") <= ALPHA)
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("\"DEF\" <= Alpha"));
  NEWLINE();
  if (ALPHA <= _imp_str_literal("DEF"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Alpha <= \"DEF\""));
  NEWLINE();
  if (_imp_str_literal("DEF") <= TRIPLE1)
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("\"DEF\" <= Triple1"));
  NEWLINE();
  if (TRIPLE1 <= _imp_str_literal("DEF"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Triple1 <= \"DEF\""));
  NEWLINE();
  if (ALPHA <= TRIPLE2)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Alpha <= Triple2"));
  NEWLINE();
  if (TRIPLE2 <= ALPHA)
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("Triple2 <= Alpha"));
  NEWLINE();
  if (TRIPLE1 <= TRIPLE2)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Triple1 <= Triple2"));
  NEWLINE();
  if (ALPHA <= ALPHA)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Alpha <= Alpha"));
  NEWLINE();
  if (_imp_str_literal("ABC") > _imp_str_literal("DEF"))
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("\"ABC\" > \"DEF\""));
  NEWLINE();
  if (_imp_str_literal("DEF") > ALPHA)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("\"DEF\" > Alpha"));
  NEWLINE();
  if (ALPHA > _imp_str_literal("DEF"))
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("Alpha > \"DEF\""));
  NEWLINE();
  if (_imp_str_literal("ABC") > TRIPLE2)
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("\"ABC\" > Triple2"));
  NEWLINE();
  if (TRIPLE1 > _imp_str_literal("DEF"))
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("Triple1 > \"DEF\""));
  NEWLINE();
  if (ALPHA > TRIPLE2)
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("Alpha > Triple2"));
  NEWLINE();
  if (TRIPLE2 > ALPHA)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Triple2 > Alpha"));
  NEWLINE();
  if (TRIPLE1 > TRIPLE2)
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("Triple1 > Triple2"));
  NEWLINES(2);
  if (_imp_str_literal("DEF") >= _imp_str_literal("ABC"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("\"DEF\" >= \"ABC\""));
  NEWLINE();
  if (_imp_str_literal("DEF") >= ALPHA)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("\"DEF\" >= Alpha"));
  NEWLINE();
  if (ALPHA >= _imp_str_literal("DEF"))
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("Alpha >= \"DEF\""));
  NEWLINE();
  if (_imp_str_literal("DEF") >= TRIPLE1)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("\"DEF\" >= Triple1"));
  NEWLINE();
  if (TRIPLE2 >= _imp_str_literal("ABC"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Triple2 >= \"ABC\""));
  NEWLINE();
  if (ALPHA >= TRIPLE2)
    FAIL();
  else
    PASS();
  PRINTSTRING(_imp_str_literal("Alpha >= Triple2"));
  NEWLINE();
  if (TRIPLE2 >= ALPHA)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Triple2 >= Alpha"));
  NEWLINE();
  if (TRIPLE2 >= TRIPLE1)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Triple2 >= Triple1"));
  NEWLINE();
  NEWLINES(5);
  PRINTSTRING(_imp_str_literal("Testing the CHAR NO Function"));
  NEWLINE();
  PRINTSTRING(_imp_str_literal("----------------------------"));
  NEWLINES(2);
  PRINTSTRING(_imp_str_literal("Let:   Beta = Ten"));
  NEWLINE();
  PRINTSTRING(_imp_str_literal("---"));
  NEWLINES(2);
  BETA = TEN;
  if (CHARNO(ALPHABET, 1) == 'A')
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("CHAR NO (Alphabet, 1) = 'A'"));
  NEWLINE();
  if (CHARNO(ALPHABET, 26) == 'Z')
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("CHAR NO (Alphabet, 26) = 'Z'"));
  NEWLINE();
  if (CHARNO(BETA, 1) == '1')
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("CHAR NO (Beta, 1) = '1'"));
  NEWLINE();
  if (CHARNO(BETA, 10) == '0')
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("CHAR NO (Beta, 10) = '0'"));
  NEWLINES(5);
  PRINTSTRING(_imp_str_literal("Test the TO STRING Function"));
  NEWLINE();
  PRINTSTRING(_imp_str_literal("---------------------------"));
  NEWLINES(2);
  if (TOSTRING('A') == _imp_str_literal("A"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("TO STRING ('A') = \"A\""));
  NEWLINE();
  if (TOSTRING(32) == _imp_str_literal(" "))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("TO STRING (32) = \" \""));
  NEWLINE();
  if (_imp_str_literal("1") == TOSTRING('1'))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("\"1\" = TO STRING ('1')"));
  NEWLINES(3);
  PRINTSTRING(_imp_str_literal("Let:    Alpha = To String (0)"));
  NEWLINE();
  PRINTSTRING(_imp_str_literal("---     Beta  = To String (255)"));
  NEWLINE();
  PRINTSTRING(_imp_str_literal("        Gamma = To String ('?')"));
  NEWLINES(2);
  ALPHA = TOSTRING(0);
  BETA = TOSTRING(255);
  GAMMA = TOSTRING('?');
  if (CHARNO(ALPHA, 1) == 0)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("CHAR NO (Alpha, 1) = 0"));
  NEWLINE();
  if (CHARNO(BETA, 1) == 255)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("CHAR NO (Beta, 1) = 255"));
  NEWLINE();
  if ('?' == CHARNO(GAMMA, 1))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("'?' = CHAR NO (Gamma, 1)"));
  NEWLINE();
  NEWLINES(5);
  PRINTSTRING(_imp_str_literal("Test the SUB STRING Function."));
  NEWLINE();
  PRINTSTRING(_imp_str_literal("-----------------------------"));
  NEWLINES(2);
  PRINTSTRING(_imp_str_literal("Let:   Beta = Ten"));
  NEWLINE();
  PRINTSTRING(_imp_str_literal("---"));
  NEWLINES(2);
  BETA = TEN;
  if (SUBSTRING(TEN, 4, 7) == _imp_str_literal("4567"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("SUB STRING (Ten, 4, 7) = \"4567\""));
  NEWLINE();
  if (SUBSTRING(BETA, 4, 7) == _imp_str_literal("4567"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("SUB STRING (Beta, 4, 7) = \"4567\""));
  NEWLINE();
  if (SUBSTRING(TEN, 4, 3) == _imp_str_literal(""))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("SUB STRING (Ten, 4, 3) = \"\""));
  NEWLINE();
  if (SUBSTRING(ALPHABET, 1, 3) == TRIPLE1)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("SUB STRING (Alphabet, 1, 3) = Triple1"));
  NEWLINE();
  NEWLINES(5);
  PRINTSTRING(_imp_str_literal("Test the LENGTH Function."));
  NEWLINE();
  PRINTSTRING(_imp_str_literal("-------------------------"));
  NEWLINES(2);
  PRINTSTRING(_imp_str_literal("Let:  Alpha = Null"));
  NEWLINE();
  PRINTSTRING(_imp_str_literal("---   Beta  = Triple2"));
  NEWLINE();
  PRINTSTRING(_imp_str_literal("      Gamma = Alphabet"));
  NEWLINES(2);
  ALPHA = NULL;
  BETA = TRIPLE2;
  GAMMA = ALPHABET;
  PRINTSTRING(_imp_str_literal("The Following THREE LINES must all"));
  PRINTSTRING(_imp_str_literal(" have the SAME number on each line."));
  NEWLINE();
  PRINTSTRING(_imp_str_literal(" 0   "));
  WRITE(LENGTH(NULL), 4);
  WRITE(LENGTH(ALPHA), 4);
  SPACES(5);
  PRINTSTRING(_imp_str_literal("LENGTHs of the NULL String."));
  NEWLINE();
  PRINTSTRING(_imp_str_literal(" 3   "));
  WRITE(LENGTH(TRIPLE2), 4);
  WRITE(LENGTH(BETA), 4);
  SPACES(5);
  PRINTSTRING(_imp_str_literal("LENGTHs of the \"DEF\" String."));
  NEWLINE();
  PRINTSTRING(_imp_str_literal("26   "));
  WRITE(LENGTH(ALPHABET), 4);
  WRITE(LENGTH(GAMMA), 4);
  SPACES(5);
  PRINTSTRING(_imp_str_literal("LENGTHs of the Upper Case Letters String."));
  NEWLINE();
  NEWLINES(5);
  PRINTSTRING(_imp_str_literal("Test the Concatenation of Strings."));
  NEWLINE();
  PRINTSTRING(_imp_str_literal("----------------------------------"));
  NEWLINES(2);
  PRINTSTRING(_imp_str_literal("Let:   Alpha = Triple1"));
  NEWLINE();
  PRINTSTRING(_imp_str_literal("---    Beta  = Triple2"));
  NEWLINE();
  PRINTSTRING(_imp_str_literal("       Gamma = \"TUVWXYZ\""));
  NEWLINES(2);
  ALPHA = TRIPLE1;
  BETA = TRIPLE2;
  GAMMA = _imp_str_literal("TUVWXYZ");
  if (_imp_join(NULL, NULL) == NULL)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Null . Null = Null"));
  NEWLINE();
  if (_imp_join(NULL, NULL) == _imp_join(NULL, _imp_join(NULL, NULL)))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Null . Null = Null . Null . Null"));
  NEWLINE();
  if (_imp_join(NULL, ALPHA) == _imp_join(TRIPLE1, NULL))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Null . Alpha = Triple1 . Null"));
  NEWLINE();
  if (_imp_join(TRIPLE1, BETA) == _imp_str_literal("ABCDEF"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Triple1 . Beta = \"ABCDEF\""));
  NEWLINE();
  if (_imp_join(_imp_str_literal("ABC"), BETA) == _imp_str_literal("ABCDEF"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("\"ABC\" . Beta = \"ABCDEF\""));
  NEWLINE();
  if (_imp_join(ALPHA, BETA) == _imp_str_literal("ABCDEF"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Alpha . Beta = \"ABCDEF\""));
  NEWLINE();
  if (_imp_join(TRIPLE1, TRIPLE2) == _imp_str_literal("ABCDEF"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Triple1 . Triple2 = \"ABCDEF\""));
  NEWLINE();
  if (_imp_str_literal("ABCDEF") == _imp_join(ALPHA, TRIPLE2))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("\"ABCDEF\" = Alpha . Triple2"));
  NEWLINE();
  if (_imp_str_literal("ABCDEF") == _imp_join(ALPHA, _imp_str_literal("DEF")))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("\"ABCDEF\" = Alpha . \"DEF\""));
  NEWLINE();
  if (_imp_str_literal("ABCDEF") == _imp_join(ALPHA, BETA))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("\"ABCDEF\" = Alpha . Beta"));
  NEWLINE();
  if (_imp_str_literal("ABCDEF") == _imp_join(TRIPLE1, TRIPLE2))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("\"ABCDEF\" = Triple1 . Triple2"));
  NEWLINE();
  if (_imp_str_literal("ABCDEF") == _imp_join(_imp_str_literal("ABC"), TRIPLE2))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("\"ABCDEF\" = \"ABC\" . Triple2"));
  NEWLINE();
  if (_imp_str_literal("ABCDEF") ==
      _imp_join(_imp_str_literal("ABC"), _imp_str_literal("DEF")))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("\"ABCDEF\" = \"ABC\" . \"DEF\""));
  NEWLINE();
  if (_imp_join(TOSTRING('A'), TRIPLE1) == _imp_str_literal("AABC"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("To String ('A') . Triple1 = \"AABC\""));
  NEWLINE();
  if (TRIPLE1 == _imp_join(TOSTRING('A'), _imp_str_literal("BC")))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Triple1 = To String ('A') . \"BC\""));
  NEWLINE();
  if (_imp_join(
          TOSTRING('A'),
          _imp_join(ALPHA, _imp_join(_imp_str_literal("DEF"), TRIPLE3))) ==
      _imp_join(_imp_str_literal("AA"),
                _imp_join(SUBSTRING(ALPHA, 2, 3),
                          _imp_join(BETA, _imp_str_literal("GHI")))))
    PASS();
  else
    FAIL();
  PRINTSTRING(
      _imp_str_literal("TO STRING ('A') . Alpha . \"DEF\" . Triple3 = "));
  NEWLINE();
  PRINTSTRING(
      _imp_str_literal("\"AA\" . SUB STRING (Alpha, 2, 3) . Beta . \"GHI\""));
  NEWLINE();
  NEWLINES(4);
  PRINTSTRING(_imp_str_literal("Combined Testing of String Functions."));
  NEWLINE();
  PRINTSTRING(_imp_str_literal("-------------------------------------"));
  NEWLINES(2);
  BETA = TRIPLE1;
  GAMMA = _imp_join(ALPHABET, _imp_join(NULL, _imp_join(TOSTRING(32), BETA)));
  PRINTSTRING(_imp_str_literal("The following TWO NUMBERS must be identical."));
  NEWLINE();
  PRINTSTRING(_imp_str_literal("30  "));
  WRITE(LENGTH(GAMMA), 2);
  NEWLINES(2);
  DELTA = TEN;
  if (TOSTRING(CHARNO(DELTA, 5)) == SUBSTRING(TEN, 5, 5))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal(
      "TO STRING (CHAR NO (Delta, 5)) = SUB STRING (Ten, 5, 5)"));
  NEWLINES(2);
  NEWLINES(4);
  PRINTSTRING(_imp_str_literal("Testing the String Resolution."));
  NEWLINE();
  PRINTSTRING(_imp_str_literal("------------------------------"));
  NEWLINES(2);
  PRINTSTRING(_imp_str_literal("Let:   Delta = Ten"));
  NEWLINE();
  PRINTSTRING(_imp_str_literal("---    Alpha = \"456\""));
  NEWLINES(2);
  ALPHA = _imp_str_literal("456");
  DELTA = TEN;
  if (!_imp_cond_resolve(DELTA, BETA, _imp_str_literal("456"), GAMMA))
    _imp_signal(7, 0, 0);
  if (BETA == _imp_str_literal("123") && GAMMA == _imp_str_literal("7890"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Delta -> Beta . (\"456\") . Gamma"));
  NEWLINE();
  if (!_imp_cond_resolve(DELTA, BETA, _imp_str_literal("456"), NULL))
    _imp_signal(7, 0, 0);
  if (BETA == _imp_str_literal("123"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Delta -> Beta . (\"456\")"));
  NEWLINE();
  if (!_imp_cond_resolve(DELTA, NULL, _imp_str_literal("456"), GAMMA))
    _imp_signal(7, 0, 0);
  if (GAMMA == _imp_str_literal("7890"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Delta -> (\"456\") . Gamma"));
  NEWLINE();
  if (DELTA == TEN)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Source unaffected."));
  NEWLINES(2);
  if (!_imp_cond_resolve(DELTA, BETA, ALPHA, GAMMA)) _imp_signal(7, 0, 0);
  if (BETA == _imp_str_literal("123") && GAMMA == _imp_str_literal("7890"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Delta -> Beta . (Alpha) . Gamma"));
  NEWLINE();
  if (!_imp_cond_resolve(DELTA, BETA, ALPHA, NULL)) _imp_signal(7, 0, 0);
  if (BETA == _imp_str_literal("123"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Delta -> Beta . (Alpha)"));
  NEWLINE();
  if (!_imp_cond_resolve(DELTA, NULL, ALPHA, GAMMA)) _imp_signal(7, 0, 0);
  if (GAMMA == _imp_str_literal("7890"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Delta -> (Alpha) . Gamma"));
  NEWLINE();
  if (DELTA == TEN)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Source unaffected."));
  NEWLINE();
  if (ALPHA == _imp_str_literal("456"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Pattern variable unaffected."));
  NEWLINES(2);
  if (!_imp_cond_resolve(DELTA, BETA, SUBSTRING(TEN, 4, 6), GAMMA))
    _imp_signal(7, 0, 0);
  if (BETA == _imp_str_literal("123") && GAMMA == _imp_str_literal("7890"))
    PASS();
  else
    FAIL();
  PRINTSTRING(
      _imp_str_literal("Delta -> Beta . (Sub String (Ten, 4, 6)) . Gamma"));
  NEWLINE();
  if (!_imp_cond_resolve(DELTA, BETA, SUBSTRING(TEN, 4, 6), NULL))
    _imp_signal(7, 0, 0);
  if (BETA == _imp_str_literal("123"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Delta -> Beta . (Sub String (Ten, 4, 6))"));
  NEWLINE();
  if (!_imp_cond_resolve(DELTA, NULL, SUBSTRING(TEN, 4, 6), GAMMA))
    _imp_signal(7, 0, 0);
  if (GAMMA == _imp_str_literal("7890"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Delta -> (Sub String (Ten, 4, 6)) . Gamma"));
  NEWLINE();
  if (DELTA == TEN)
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Source unaffected."));
  NEWLINE();
  if (!_imp_cond_resolve(DELTA, DELTA, _imp_str_literal("456"), BETA))
    _imp_signal(7, 0, 0);
  if (DELTA == _imp_str_literal("123") && BETA == _imp_str_literal("7890"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Delta -> Delta . (\"456\") . Beta"));
  NEWLINES(3);
  PRINTSTRING(_imp_str_literal("Let:   Delta = Ten"));
  NEWLINE();
  PRINTSTRING(_imp_str_literal("---"));
  NEWLINES(2);
  DELTA = TEN;
  if (!_imp_cond_resolve(DELTA, DELTA, ALPHA, BETA)) _imp_signal(7, 0, 0);
  if (DELTA == _imp_str_literal("123") && BETA == _imp_str_literal("7890"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Delta -> Delta . (Alpha) . Beta"));
  NEWLINE();
  NEWLINES(3);
  PRINTSTRING(_imp_str_literal("Let:    Delta = Ten"));
  NEWLINE();
  PRINTSTRING(_imp_str_literal("---"));
  NEWLINES(2);
  DELTA = TEN;
  if (_imp_cond_resolve(DELTA, NULL, _imp_str_literal("456"), NULL))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Delta -> (\"456\") condition."));
  NEWLINE();
  if (_imp_cond_resolve(DELTA, NULL, ALPHA, NULL))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Delta -> (Alpha) condition."));
  NEWLINE();
  if (_imp_cond_resolve(DELTA, BETA, ALPHA, GAMMA))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Delta -> Beta . (Alpha) . Gamma condition."));
  NEWLINE();
  if (BETA == _imp_str_literal("123") && GAMMA == _imp_str_literal("7890"))
    PASS();
  else
    FAIL();
  PRINTSTRING(_imp_str_literal("Assignment of BETA and GAMMA"));
  NEWLINE();
  SELECTOUTPUT(0);
  WRITE(FAILURES, 1);
  PRINTSTRING(_imp_str_literal(" failure(s)"));
  NEWLINE();
  _imp_leave();
  exit(0);
  return (0);
}
