#include <perms.h>
int _imp_mainep(int _imp_argc, char **_imp_argv) {
  _imp_enter();
  const int NMAX = 20;
  auto void TESTMATRIX(double *A, int N);
  auto void HOUSEHOLDER(double *A, double *W, int N, int K);
  int I;
  double A[NMAX - 1 + 1][NMAX - 1 + 1];
  double W[NMAX - 1 + 1];
  TESTMATRIX(A, NMAX);
  PRINTSTRING(_imp_str_literal("\nTEST MATRIX EIGENVALUES\n"));
  HOUSEHOLDER(A, W, NMAX, 1);
  for (I = 1; I != NMAX + 1; I += 1) {
    PRINTFL(W, 8);
    NEWLINE();
  }
  exit(0);
  auto void TESTMATRIX(double *A, int N) {
    _imp_enter();
    int I;
    int J;
    double T;
    double C;
    double D;
    double F;
    C = N * (N + 1) * (2 * N - 5) / 6;
    D = 1 / C;
    *A(/*index missing*/) = -D;
    for (I = 1; I != N - 1 + 1; I += 1) {
      F = I;
      *A(/*index missing*/) = D * F;
      *A(/*index missing*/) = A;
      *A(/*index missing*/) = D * (C - REXP(F, 2));
      for (J = 1; J != I - 1 + 1; J += 1) {
        T = J;
        *A(/*index missing*/) = -D * F * T;
        *A(/*index missing*/) = A;
      }
    }

    _imp_leave();
  }
  auto void HOUSEHOLDER(double *A, double *W, int N, int K) {
    _imp_enter();
    auto void HOUSEHOLDERTRIDIAGONALISATION(double *A, double *B, double *C,
                                            int N);
    auto void TRIDIBISECTION(double *C, double *B, double *W, int N,
                             double *NORM);
    auto void TRIDIINVERSEITERATION(double *C, double *B, double *W, double *Z,
                                    int N, double NORM);
    auto void BACKTRANSFORMATION(double *A, double *B, double *Z, int N);
    double Z[N - 1 + 1][N - 1 + 1];
    double B[N - 1 + 1], C[N - 1 + 1];
    int I;
    int J;
    double NORM;
    double TEN;
    TEN = 10;
    HOUSEHOLDERTRIDIAGONALISATION(A, B, C, N);
    TRIDIBISECTION(C, B, W, N, NORM);
    if (K == 2) {
      _imp_leave();
      return;
    }
    TRIDIINVERSEITERATION(C, B, W, Z, N, NORM);
    BACKTRANSFORMATION(A, B, Z, N);
    for (I = 1; I != N + 1; I += 1) {
      for (J = 1; J != N + 1; J += 1) {
        *A(/*index missing*/) = Z;
      }
    }
    {
      _imp_leave();
      return;
    }
    auto void HOUSEHOLDERTRIDIAGONALISATION(double *A, double *B, double *C,
                                            int N) {
      _imp_enter();
      int I;
      int J;
      int K;
      double AI;
      double SIGMA;
      double H;
      double BJ;
      double BIGK;
      double BI;
      double Q[N - 1 - 1 + 1];
      for (I = N; I != 3 + -1; I += -1) {
        SIGMA = 0;
        for (K = 1; K != I - 1 + 1; K += 1) {
          SIGMA = SIGMA + REXP(A, 2);
        }
        AI = A;
        if (AI >= 0)
          BI = -SQRT(SIGMA);
        else
          BI = SQRT(SIGMA);
        *B(/*index missing*/) = BI;
        if (BI == 0) continue;
        H = SIGMA - AI * BI;
        *A(/*index missing*/) = AI - BI;
        for (J = I - 1; J != 1 + -1; J += -1) {
          BJ = 0;
          for (K = I - 1; K != J + -1; K += -1) {
            BJ = BJ + A * A;
          }
          for (K = J - 1; K != 1 + -1; K += -1) {
            BJ = BJ + A * A;
          }
          Q[J] = BJ / H;
        }
        BIGK = 0;
        for (J = I - 1; J != 1 + -1; J += -1) {
          BIGK = BIGK + A * Q[J];
        }
        BIGK = BIGK / (2 * H);
        for (J = I - 1; J != 1 + -1; J += -1) {
          Q[J] = Q[J] - BIGK * A;
        }
        for (J = I - 1; J != 1 + -1; J += -1) {
          for (K = J; K != 1 + -1; K += -1) {
            *A(/*index missing*/) = A - A * Q[K] - A * Q[J];
          }
        }
      }
      for (I = N; I != 1 + -1; I += -1) {
        *C(/*index missing*/) = A;
      }
      *B(/*index missing*/) = A;
      *B(/*index missing*/) = 0;
      _imp_leave();
    }
    auto void TRIDIINVERSEITERATION(double *C, double *B, double *W, double *Z,
                                    int N, double NORM) {
      _imp_enter();
      int I;
      int J;
      double BI;
      double BI1;
      double Z1;
      double LAMBDA;
      double U;
      double S;
      double V;
      double H;
      double EPS;
      double ETA;
      double M[N - 1 + 1], P[N - 1 + 1], Q[N - 1 + 1], R[N - 1 + 1],
          INT[N - 1 + 1];
      double X[N + 2 - 1 + 1];
      LAMBDA = NORM;
      EPS = NORM / (REXP(TEN, 11));
      for (J = 1; J != N + 1; J += 1) {
        LAMBDA = LAMBDA - EPS;
        if (W < LAMBDA) LAMBDA = W;
        U = C - LAMBDA;
        V = B;
        if (V == 0) V = EPS;
        for (I = 1; I != N - 1 + 1; I += 1) {
          BI = B;
          if (BI == 0) BI = EPS;
          BI1 = B;
          if (BI1 == 0) BI1 = EPS;
          if (MOD(U) > MOD(BI)) {
            M[I + 1] = BI / U;
            P[I] = U;
            Q[I] = V;
            R[I] = 0;
            U = C - LAMBDA - M[I + 1] * V;
            V = BI1;
            INT[I + 1] = -1;

          } else {
            M[I + 1] = U / BI;
            if (M[I + 1] == 0 && BI <= EPS) M[I + 1] = 1;
            P[I] = BI;
            Q[I] = C - LAMBDA;
            R[I] = BI1;
            U = V - M[I + 1] * Q[I];
            V = -M[I + 1] * R[I];
            INT[I + 1] = 1;
          }
        }
        P[N] = U;
        Q[N] = 0;
        R[N] = 0;
        X[N + 1] = 0;
        X[N + 2] = 0;
        H = 0;
        ETA = 1 / N;
        for (I = N; I != 1 + -1; I += -1) {
          U = ETA - Q[I] * X[I + 1] - R[I] * X[I + 2];
          if (P[I] != 0)
            X[I] = U / P[I];
          else
            X[I] = U / EPS;
          H = H + MOD(X[I]);
        }
        H = 1 / H;
        for (I = 1; I != N + 1; I += 1) {
          X[I] = X[I] * H;
        }
        for (I = 2; I != N + 1; I += 1) {
          if (INT[I] <= 0)
            X[I] = X[I] - M[I] * X[I - 1];
          else {
            U = X[I - 1];
            X[I - 1] = X[I];
            X[I] = U - M[I] * X[I - 1];
          }
        }
        H = 0;
        for (I = N; I != 1 + -1; I += -1) {
          U = X[I] - Q[I] * X[I + 1] - R[I] * X[I + 2];
          if (P[I] == 0)
            X[I] = U / EPS;
          else
            X[I] = U / P[I];
          H = H + X[I] * X[I];
        }
        H = 1 / SQRT(H);
        for (I = 1; I != N + 1; I += 1) {
          *Z(/*index missing*/) = X[I] * H;
        }
      }

      _imp_leave();
    }
    auto void TRIDIBISECTION(double *C, double *B, double *W, int N,
                             double *NORM) {
      _imp_enter();
      double L;
      double G;
      double H;
      double LAMBDA;
      double P1;
      double Q1;
      double Y;
      int I;
      int J;
      int K;
      int A1;
      int A2;
      double P[N - 1 + 1];
      P[1] = 0;
      *NORM = MOD(C) + MOD(B);
      for (I = 2; I != N + 1; I += 1) {
        L = MOD(B) + MOD(C) + MOD(B);
        if (L > NORM) *NORM = 1;
      }
      for (I = 1; I != N - 1 + 1; I += 1) {
        if (B == 0)
          P[I + 1] = NORM * NORM / REXP(TEN, 23);
        else
          P[I + 1] = B * B;
      }
      for (K = 1; K != N + 1; K += 1) {
        G = NORM;
        H = -NORM;
        for (J = 1; J != 39 + 1; J += 1) {
          LAMBDA = (G + H) / 2;
          P1 = 0;
          Q1 = 1;
          A1 = 0;
          for (I = 1; I != N + 1; I += 1) {
            Y = (C - LAMBDA) * Q1 - P[I] * P1;
            P1 = Q1;
            Q1 = Y;
            if ((P1 >= 0 && Q1 >= 0) || (P1 < 0 && Q1 < 0)) A1 = A1 + 1;
          }
          if (Q1 == 0 && P1 > 0) A1 = A1 - 1;
          if (A1 >= K)
            H = LAMBDA;
          else
            G = LAMBDA;
        }
        *W(/*index missing*/) = (G + H) / 2;
      }
      {
        _imp_leave();
        return;
      }
      _imp_leave();
    }
    auto void BACKTRANSFORMATION(double *A, double *B, double *Z, int N) {
      _imp_enter();
      int I;
      int J;
      int K;
      double S;
      for (J = 1; J != N + 1; J += 1) {
        for (K = 3; K != N + 1; K += 1) {
          if (B == 0) continue;
          S = 0;
          for (I = 1; I != K - 1 + 1; I += 1) {
            S = S + A * Z;
          }
          S = S / (B * A);
          for (I = 1; I != K - 1 + 1; I += 1) {
            *Z(/*index missing*/) = Z + S * A;
          }
        }
      }

      _imp_leave();
    }

    _imp_leave();
  }

  _imp_leave();
  exit(0);
  return (0);
}
